package tools.descartes.dql.connector.kieker;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.util.concurrent.TimeUnit;

import kieker.monitoring.core.controller.IMonitoringController;
import kieker.monitoring.core.controller.MonitoringController;
import kieker.monitoring.sampler.sigar.ISigarSamplerFactory;
import kieker.monitoring.sampler.sigar.SigarSamplerFactory;
import kieker.monitoring.sampler.sigar.samplers.CPUsDetailedPercSampler;
import kieker.monitoring.sampler.sigar.samplers.MemSwapUsageSampler;

public final class ResourceMonitor {
	static Process p;
	
	static void startResourceMonitor(String pathToKieker, String pathToConfig)
	{
		char quotationMarks = '"';
		try {
			
			String command = "java -cp " 
			+quotationMarks + pathToKieker +File.separator+ "lib"+File.separator+"*"+quotationMarks+";"
			+quotationMarks + pathToKieker +File.separator+ "lib"+File.separator+"sigar"+File.separator+"*"+quotationMarks+";"
			+quotationMarks + pathToKieker +File.separator+ "build"+File.separator+"libs"+File.separator+"*"+quotationMarks+";"
			+quotationMarks + pathToConfig +File.separator+"*"+quotationMarks+";"
			+quotationMarks + pathToKieker +File.separator+ "bin"+quotationMarks
			+" kieker.tools.resourceMonitor.ResourceMonitor";
			
			System.out.println("CMD:"+command);
			p = Runtime.getRuntime()
					.exec(command);
			String line;
			BufferedReader in = new BufferedReader(new InputStreamReader(p.getErrorStream()));
			/*while ((line = in.readLine()) != null) {
				System.out.println(line);
			}*/
			in.close();
		} catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
			throw new IllegalStateException("Could not execute application with kieker");
		}
		
	}
	
	static void stopRessourceMonitor(){
		p.destroy();
	}
}